<?php

###############################################################################
#                                                                             #
# Library File for pkIRIS-CA                                                  #
#                                                                             #
###############################################################################


################################### FUNCTIONS #################################

#
# function cabecera: anyade al codigo desde el que se invoca la funcion el
# menu con las opciones disponibles. Tambien anyade informacion como el 
# titulo de la pagina o el logo de la organizacion entre otras cosas. 
# Normalmente se llamara al principio del codigo, mostrando la informacion 
# a modo de cabecera de pagina.
#
function cabecera($idCabecera) {
   global $menu;
   global $ldapVar;
   global $pkiris;
   
   $tabText = "pkIRIS";
   $errorCode = "a0";
   echo "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN'
   'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>
    <html xmlns='http://www.w3.org/1999/xhtml' xml:lang='es'>
    <head>
       <meta http-equiv='content-type' content='text/html;charset=utf-8' />
       <link rel='shortcut icon' href='../images/favicon.ico' />
       <title>CICA | Infraestructura de Clave P&uacute;blica</title>
       <style type='text/css' media='all'>@import '/styles/pkiris.css';</style>
    </head>\n";

   $tabText = "CA";
   echo "<body#pkiris>
   <div id='container'>
      <div id='pkHeader'>
         <img alt='logo' src='/images/pkiris-sample-logo.png'>
	 <div id='galipollo'>
	    <img alt='galipollo' src='/images/pkiris-galipollo-logo.png'>
	 </div> <!-- galipollo -->
      </div> <!-- pkHeader -->
      <div id='nav'>
         <ul>
         <li><a href='".$pkiris['homeURL']."' title='Home'>Home</a></li>
      </div>
      <div id='nav_sombra'></div>
       </ul>
       <div id='pkBody'>
         <div id='sidebar'>

       <div id='tbox'>
       <h3 class='head_a1b1'>$tabText</h3>
        <ul>\n";
															       
   while (list ($index, $content) = each ($menu[$idCabecera])) {
      echo "<li><a href='$index'>$content</a></li>";
   }
   echo "</ul>
      </div> <!--tbox menu-->\n";
   if ( $pkiris['authMethod'] != "none" ){
      echo "<!-- Ini: Login -->
      <div id='tbox'>\n";
      if (!isset($_SESSION['user']) ) {
            echo "
             <h3 class='head_a1b1'>Login</h3>
             <form action='/auth.php' method='post'>
               <div id='tbox_data_a1b1'>
                  Usuario<br/>
                  <input type='text' name='user' size='23' /><br/>
                  Clave<br/>
                  <input type='password' name='passwd' size='23' /><br />
                     <input class='button' type='submit' name='boton1' value='Entrar' />
               </div>
            </div>
            <!-- End: Login -->
            </form>\n";
      }
      else {
            echo "
            <h3 class='head_a1b1'>Login</h3>
            <div id='tbox_data_a1b1'>
            Bienvenid@<br/>\n";
            $user = $_SESSION['user'];
            $filter = "(&(objectClass=pkirisEndEntity)(pkirisID=$user))";
            $justthese = array("cn", "sn");
            $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
            if (!$result)
               $errorCode = "a1b2c1";
            else if ( $result['count'] > 0 && $pkiris['authMethod'] == "ldap" )
               echo $result[0]["cn"][0]. " " . $result[0]["sn"][0]."<br/>";
            else
               echo $user . "<br/>";
            echo "<a class='login' href='/close_session.php'>&nbsp;Cerrar sesi&oacute;n&nbsp;</a><br/>
            </div>\n";
      }
      echo"</div> <!-- tbox login -->\n";
   }
   echo "</div><!--sidebar-->
   <div id='content'>\n";

   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

#
# function pie: anyade informacion al codigo desde el que se invoca a la 
# funcion. Normalmente esta funcion se llamara al final del codigo, a modo de
# pie de pagina.
#
function pie() {
   echo "</div> <!-- content -->
   </div> <!-- pkBody -->\n
   <div id=\"ie_fix_01\"><!-- Mamoneo IE --></div>\n
   <div id='pkFooter'>
      <div id='url'>
        <a href='http://www.rediris.es/app/pkiris/'><img
           border='0' src='/images/pkiris-icon.png'></a>
      </div>
      <div id='credits'>
         pkIRIS 2005-2006
      </div>
   </div> <!-- pkFooter -->
   </div> <!-- container -->
</body>
</html>\n";
				 
}

#
# function getLastComment: return the last comments of the pkirisTraces
#
function getLastComment ($copa) {
   global $ldapVar;
   global $pkiris;
   global $traceIndices;   

   $errorCode = "a0";
   $retValue = false;
   $lastDate = 0;
   $filter = "(&(objectClass=pkirisCertificate)(".$ldapVar['rdnAttr']."=$copa))";
   $dn = $ldapVar['rdnAttr']."=$copa,".$ldapVar['base'];
   $justthese = array ("pkiristrace");
   // Obtenemos todas las trazas de la solicitud con numero copa indicado por $copa
   $pkirisTraces = ldap_get_info($dn,$filter,$justthese);
   if ( !$pkirisTraces )
      $errorCode = "a1b2c1";
   else {
      if ( $pkirisTraces['count'] > 0 ) {
         while (list($index, $value) = each($pkirisTraces[0]["pkiristrace"])) {
            // Parseamos la traza por el prefijo $pkiris['urnPrefix']
            list($k, $tmp) = split($pkiris['urnPrefix'], $value);
            // y metemos en un array el resto de componentes de la traza
            $tr = split(":", $tmp);
            // Le quitamos el primer elemento porque no contiene nada
            array_shift ($tr);
            // En traceIndices['status'] se encuentra el indice correspondiente al 
            // campo que contiene el estado de la traza (0, 1 ... n), y en
            // traceIndices['date'] el de la fecha
            $tmpStatus = $tr[$traceIndices['status']];
            list($k, $comment) = split ("comment=", $tmpStatus);

            $date = $tr[$traceIndices['date']];
      
            if ( ($date > $lastDate) && ($comment != '') ) {
               $lastDate = $date;
	       $retValue = str_replace("%59", ";", $comment);
            }
         }
      }
   }

   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function parseXML: construye y devuelve un array con todos los tags del 
# codigo XML correspondiente al fichero de entrada. Sera un array multivaluado 
# indexado por el numero de solicitud dentro del fichero, seguido del nombre 
# del tag y su valor. La posicion '0' esta reservada para informacion del 
# propio fichero. Si hay algun error, devuelve 'false'.
#
function parseXML ($xmlFile) {
   global $raPrivKey;
   global $pkiris;
   global $traceIndices; 
   
   $errorCode = "a0";
   $retValue = false;
   // Creamos un array con las expresiones regulares que parsearemos
   // el fichero XML.
 
   // Expresiones comunes a todos los tipos de XML
   $regex['pki'] = "/<pki type=(.*) version=.*>\n(.*?)\n<\/pki>/ms";
   $regex['header'] = "/<header>(.*?)<\/header>/ms";
   $regex['data'] = "/<data>(.*?)<\/data>/ms";
   $regex['sig'] = "/<sig>(.*?)<\/sig>/";
   $regex['total_sig'] = "/<total_sig>(.*)?<\/total_sig>/";
   
   $regex['dn'] = "/<dn>(.*?)<\/dn>/";
   $regex['id'] = "/<id>(.*?)<\/id>/";
   $regex['copa_id'] = "/<copa_id>(.*?)<\/copa_id>/";
   $regex['traces'] = "/<traces>(.*?)<\/traces>/ms";
   $regex['traceurn']= "/<trace>(urn:mace:rediris.es:.+:.+:csr:state:.+:.+:.+)<\/trace>/";
   
   // Leemos el fichero con las solicitudes y los pasamos a una cadena
   $xmlContent = file_get_contents($xmlFile);
   
   if ( !$xmlContent )
      $errorCode = "a1b2c4"; 
   else {
         // Obtenemos el tipo de XML y lo guardamos en arrayData
         $r = preg_match($regex['pki'], $xmlContent, $xmlInfo['pki']);
         if ( !$r )
            $errorCode = "a1b2c5";
	 else {
            $xmlType = $xmlInfo['pki'][1];
            $arrayData[0]['xmlType'] = $xmlType;
     
            // CSRs 
            if ( $xmlType == '"csr"') {
	       // Expresiones regulares que nos serviran para obtener la informacion
	       // de los ficheros que contengan solicitudes de certificados
               $regex['requests_type'] = "/(<csrs>.*?<\/csrs>)/ms";
               $regex['request_type'] = "/<(csr|rnr)>(.*?)<\/csr|rnr>/ms";
	       $regex['nav_type'] = "/<nav_type>(.*?)<\/nav_type>/";
	       $regex['ee_type'] = "/<ee_type>(.*?)<\/ee_type>/";
	       $regex['mail'] = "/<mail>(.*?)<\/mail>/";
	       $regex['show_mail'] = "/<show_mail>(.*?)<\/show_mail>/";
	       $regex['subject_dn'] = "/<subject_dn>(.*?)<\/subject_dn>/";
            }
      
            // CRRs
            else if ($xmlType == '"crr"') {
	       // Expresiones regulares que nos serviran para obtener la informacion
               // de los ficheros que contengan solicitudes de revocacion 
	       $regex['request_type'] = "/<(crr)>(.*?)<\/crr>/ms";
	       $regex['serial'] = "/<serial>(.*?)<\/serial>/";
	       $regex['revoked_by'] = "/<revoked_by>(.*?)<\/revoked_by>/";
	       $regex['reason'] = "/<reason>(.*?)<\/reason>/";
	       $regex['invalidity_date'] = "/<invalidity_date>(.*?)<\/invalidity_date>/";
            }
            // PRIVATE (XML con la clave privada de la RA)
            else if ( $xmlType == '"privado"' ) {
               $regex['request_type'] = "/<(privado)>(.*?)<\/(privado)>/ms";
	       $regex['private_key'] = "/<private_key>(.*?)<\/private_key>/";
	       $regex['date'] = "/<date>(.*?)<\/date>/";
            }
            else 
               $errorCode = "a1b2c6"; //XML no soportado
 
            // Parsearemos el fichero y todas sus solicitudes utilizando
            // la misma clave de secreto compartido (la de la CA). Pero 
            // para firmar cada fichero usaremos la clave de secreto
	    // compartido correspondiente a su RA, la cual obtendremos del 
	    // fichero de claves. Para el caso de privado no hace falta ya 
            // que la clave privada la coge del propio XML
            if ( $xmlType != '"privado"') {
               // Obtenemos los numeros copa del XML
      	       $r = preg_match($regex['copa_id'], $xmlContent, $xmlInfo['copa_id']);
	       if ( !$r )
		  $errorCode = "a1b2c5";
	       else {
	          // y nos quedamos con el numero de ra ('ai')
	          list ($raCopa, $k) = split ("b", $xmlInfo['copa_id'][1]);
	          $privKey = getRaPrivKey($raCopa);
	          if ( !$privKey ) 
	             $errorCode = "a1b2c10";
	       }
            }

            if ( $errorCode == "a0" ) {       
               // Nos quedamos con todas las solicitudes del tipo 'requestsType' (lo que 
               // va entre <csrs> y </csrs> en las CSRs). El caso de las CRRs tendra un 
               // tratamiento diferente ya que no contiene este tipo de etiquetas (solo
               // viene una solicitud por fichero). Los XML que exportan la clave 
               // privada de la RA tampoco tienen estas etiquetas ni 'total_sig'
               if ( $xmlType != '"crr"' && $xmlType != '"privado"' ) {
                  $r = preg_match($regex['requests_type'], $xmlContent, $xmlInfo['allRequests']);
    		  if ( !$r )
                     $errorCode = "a1b2c5";
                  else {
                     // Obtenemos la firma del fichero
                     $r = preg_match($regex['total_sig'], $xmlContent, $xmlInfo['total_sig']);
		     if ( !$r )
                        $errorCode = "a1b2c5";
                     else {
                        $arrayData[0]['total_sig'] = $xmlInfo['total_sig'][1];
                        // Comprobamos que los xmlContent no han sido modificados firmando con
                        // la clave secreta de la RA. Tenemos que anyadirle un salto de linea
                        // al bloque de las solicitudes
                        $sha1_file_sig = sha1($xmlInfo['allRequests'][1] . "\n" . $privKey);
                     }
                  }
               }
               // En el caso de las CRRs y privado no tenemos "total_sig", por lo que
               // inicializamos $xmlInfo['total_sig'] y '$sha1_file_sig' a false
               else {
	          $sha1_file_sig = false;     
                  $xmlInfo['total_sig'][1] = $sha1_file_sig;
               }	 

               if ($xmlInfo['total_sig'][1] == $sha1_file_sig) {
                  // Vamos a analizar cada solicitud
                  $csrsNumber = preg_match_all($regex["request_type"], $xmlContent, $xmlInfo['requests']);
		  if ( !$csrsNumber )
                        $errorCode = "a1b2c5";
                  else {
                     for ($i = 0; $i < $csrsNumber; $i++) {
	                // Obtenemos el tipo de solicitud y la propia solicitud
   	                $request_type = $xmlInfo['requests'][1][$i];
                        $currentRequest = $xmlInfo['requests'][2][$i];
	  
 	                // La informacion de la primera solicitud empezara en la posicion
	                // 1 del array
	                $index = $i+1; 
	    
   	                // Para el caso de privado, solo hay que guardar el numero copa de
	                // la RA, su clave privada y la fecha de validez de la misma. No 
	                // tiene trazas a las que calcularle la firma
	                // PRIVATE
                        if ( $xmlType == '"privado"' ) {
                           $r = preg_match($regex['copa_id'], $currentRequest, $xmlInfo['copa_id']);
	                   $r = preg_match($regex['date'], $currentRequest, $xmlInfo['date']);
                           $r = preg_match($regex['private_key'], $currentRequest, $xmlInfo['private_key']);
	                   $r = preg_match($regex['sig'], $currentRequest, $xmlInfo['sig']);
                           $arrayData[$index]['copa_id'] = $xmlInfo['copa_id'][1];
   	                   $arrayData[$index]['date'] = $xmlInfo['date'][1];
                           $arrayData[$index]['private_key'] = $xmlInfo['private_key'][1];
                           $arrayData[$index]['sig'] = $xmlInfo['sig'][1];
	      
	                   // Componemos una cadena con la informacion de la solicitud
                           // para verificar si su suma de control sha1 es correcta
                           $cadena = "<copa_id>".$xmlInfo['copa_id'][1]."</copa_id>\n<date>".$xmlInfo['date'][1]."</date>\n<private_key>".$xmlInfo['private_key'][1]."</private_key>\n";
	                   // Obtenemos la suma sha1 de la cadena + claveRA + pkirisCopaID
                           $sha1_request_sig = sha1($cadena.$xmlInfo['private_key'][1].$xmlInfo['copa_id'][1]);
	                   if ( $sha1_request_sig != $xmlInfo['sig'][1] ) 
                  	      $errorCode = "a1b3c7";
                        }                                       									           else {														        // Sacamos la informacion del fichero XML. Datos comunes a
                          // los diferentes tipos de XML
	                  $r = preg_match($regex['header'], $currentRequest, $xmlInfo['header']);
	                  $r = preg_match($regex['data'], $currentRequest, $xmlInfo['data']);
	                  $r = preg_match($regex['sig'], $currentRequest, $xmlInfo['sig']);
   	                  $r = preg_match($regex['id'], $xmlInfo['header'][1], $xmlInfo['id']);
                          $r = preg_match($regex['copa_id'], $xmlInfo['header'][1], $xmlInfo['copa_id']); 
	                  $r = preg_match($regex['dn'], $xmlInfo['header'][1], $xmlInfo['dn']);
	                  $r = preg_match($regex['traces'], $xmlInfo['header'][1], $xmlInfo['traces']);
                          $tracesNumber = preg_match_all($regex['traceurn'], $xmlInfo['traces'][1], $xmlInfo['traceurn']);
            
	                  // Y la anyadimos al array de retorno (menos data y sig que se 
	                  // anyadiran al final). Dejamos la posicion 0 del array para datos 
	                  // comunes a las solicitudes. 
	                  for ($j = 0; $j < $tracesNumber; $j++)
                             $arrayData[$index]['traces'][$j] = $xmlInfo['traceurn'][1][$j]; 

                          $arrayData[$index]['id'] = $xmlInfo['id'][1];
                          $arrayData[$index]['copa_id'] = $xmlInfo['copa_id'][1];
	                  $arrayData[$index]['dn'] = $xmlInfo['dn'][1];
	                  $arrayData[$index]['requesttype'] = $request_type;
	    
	                  // Dependiendo si es un tipo u otro de estructura XML, 
	                  // obtendremos una informacion adicional direfente
	    
	                  // CSRs 
	                  if ( $xmlType == '"csr"' ) { 
      	                     $r = preg_match($regex['nav_type'], $xmlInfo['header'][1], $xmlInfo['nav_type']);
   	                     $r = preg_match($regex['ee_type'], $xmlInfo['header'][1], $xmlInfo['ee_type']);
   	                     $r = preg_match($regex['mail'], $xmlInfo['header'][1], $xmlInfo['mail']);
	                     $r = preg_match($regex['show_mail'], $xmlInfo['header'][1], $xmlInfo['show_mail']);
 	                     $r = preg_match($regex['subject_dn'], $xmlInfo['header'][1], $xmlInfo['subject_dn']);
	    
	                     // Completamos arrayData con la informacion que acabamos de
                             // obtener del XML
                             $arrayData[$index]['nav_type'] = $xmlInfo['nav_type'][1];
      	                     $arrayData[$index]['ee_type'] = $xmlInfo['ee_type'][1];
	                     $arrayData[$index]['mail'] = $xmlInfo['mail'][1];
                             $arrayData[$index]['show_mail'] = $xmlInfo['show_mail'][1];
                             $arrayData[$index]['subject_dn'] = $xmlInfo['subject_dn'][1];
                           }

   	                   // CRRs
	                   else if ( $xmlType == '"crr"' ) {
                              $r = preg_match($regex['serial'], $xmlInfo['header'][1], $xmlInfo['serial']);
                              $r = preg_match($regex['revoked_by'], $xmlInfo['header'][1], $xmlInfo['revoked_by']);
   	                      $r = preg_match($regex['reason'], $xmlInfo['header'][1], $xmlInfo['reason']);
	                      $r = preg_match($regex['invalidity_date'], $xmlInfo['header'][1], $xmlInfo['invalidity_date']);

	                      // Completamos arrayData con la informacion que acabamos de
                              // obtener del XML
                              $arrayData[$index]['serial'] = $xmlInfo['serial'][1];
                              $arrayData[$index]['revoked_by'] = $xmlInfo['revoked_by'][1];
	                      $arrayData[$index]['reason'] = $xmlInfo['reason'][1];
	                      $arrayData[$index]['invalidity_date'] = $xmlInfo['invalidity_date'][1];
	                   }

	                   // Le anyadimos al array la firma de la solicitud
	                   $arrayData[$index]['sig'] = $xmlInfo['sig'][1];
	   
	                   // Componemos una cadena con la informacion de la solicitud
                           // para verificar si su suma de control sha1 es correcta
                           $cadena = "<header>".$xmlInfo['header'][1]."</header>\n";
	    
	                   // Le anyadimos al array el contenido del tag 'data'
			   // (en caso de que no sea un XML del tipo privado. 
                           // Tambien hay que añadirselo a la cadena
	                   if ( $request_type != "privado") {
	                      $arrayData[$index]['data'] = $xmlInfo['data'][1];	       
                              $cadena = $cadena . "<data>".$xmlInfo['data'][1]."</data>\n";
	                   }

                           // Obtenemos la suma sha1 de la cadena + claveRA + pkirisCopaID
                           $sha1_request_sig = sha1($cadena . $privKey . $xmlInfo['copa_id'][1]);
	    
                           if ( $xmlInfo['sig'][1] == $sha1_request_sig ) { 
  	                      // Tenemos que comprobar las firmas de todas trazas		 		 
	                      $found = false;
                              while ( (list (,$value) = each($arrayData[$index]['traces'])) && !$found) {
                                 // Parseamos la traza por el prefijo $pkiris['urnPrefix']
                                 list($k, $tmp) = split($pkiris['urnPrefix'], $value);
                                 // y metemos en un array el resto de componentes de la traza
		                 $tr = split(":", $tmp);
      		                 // Le quitamos el primer elemento porque no contiene nada
                                 array_shift ($tr);
		  
                                 // En traceIndices['sha1'] se encuentra el indice 
		                 // correspondiente al campo que contiene la firma de la 
		                 // traza ($0, $1 ... $4)
		                 $sigIndex = $traceIndices['sha1'];
                                 $traceSig = $tr[$sigIndex];
		  
                                 // Componemos la cadena a verificar. Usaremos todos los 
                                 // componentes de la traza menos la firma sha1
	      	                 $g = 0;
		                 while( $g < count($tr) ) {
		                    // Si no es la firma, insertamos el elemento en el array
		                    if ( $g != $sigIndex )
		                       $trAux[$g] = $tr[$g];
		                       // Si es el componente con la firma y no es el ultimo 
		                       // elemento, insertamos el siguiente en el array
		                    else if ( $g != count($tr) -1 ) {  
		                       $trAux[$g] = $tr[$g+1];
			               $g++;
		                    }			
		                    $g++;
		                 }
		  
                                 $cadena =  $pkiris['urnPrefix'].":$trAux[0]:$trAux[1]:$trAux[2]:$trAux[3]";
		                 // Obtenemos el sha1 de la cadena		 
		                 $sha1_trace_sig = sha1($cadena . $privKey . $xmlInfo['copa_id'][1]);
                                 if ($traceSig != $sha1_trace_sig) {
                                    $found = true;
	                            $errorCode = "a1b2c9";
                                 }
                              } //endwhile		    		 
                           }
	                   else 
                              $errorCode = "a1b2c8";
	                } 
                     } //endfor  
                  }
               }
               else 
                  $errorCode = "a1b2c7";
            }
         }
   }
   if ($errorCode == "a0")
      $retValue = $arrayData;
   
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function createXML: esta funcion crea un fichero con el codigo XML de todas 
# las solicitudes, el cual sirve para transmitir informacion entre la RA y la 
# CA. Recibe un array los codigos copa de las solicitudes o los certificados 
# que van a ser exportados, y devuelve una cadena con el codigo XML si no ha 
# habido ningun error o 'false' en el caso de que si los haya habido. Esta 
# funcion crea un fichero con el codigo XML de todas las solicitudes, el cual 
# sirve para transmitir informacion entre la RA y la CA.
#
function createXML ($copasArray) {
   global $ldapVar;
   global $raPrivKey;
   global $pkiris;
   global $bin;
   global $dirVar; 
 
   $errorCode = "a0"; 
   $xmlString = "";
   $retValue = false;
   $initializedXmlFileInfo = false;   
   
   // Tratamos todas las solicitudes con los numeros copa incluidos en el array
   // de entrada '$copasArray'. Si hay algun error paramos
   while ( (list(,$copa) = each ($copasArray)) && $errorCode == "a0" ) {
      $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))"; 
      $justthese = array ("dn","pkirisid","pkirisstatus","pkiristrace");
      $info = ldap_get_info($ldapVar['base'],$filter,$justthese);
      if ( !$info ) 
         $errorCode = "a1b2c1";
      else {
	 $status = $info[0]['pkirisstatus'][0];
         // En '$exportStatus' guardamos el estado al que tendremos que
         // cambiar la solicitud cuando se haya generado el XML, es decir,
         // 'ca2ra' (exportada de la CA a la RA)
         $exportStatus = "ca2ra";
         // La exporatcion de puede realizar desde estados diferentes. 
	 // Dependiendo si es uno u otro las variables tomaran unos valores u 
	 // otros:
	 if ( $status == "issued" ) { 
	    $requestType = "crt";
	    // Dependiendo si es una solicitud o una renovacion de certificado,
	    // anyadiremos las trazas desde la que tenga el estado 
	    // 'csr-pending' o 'rnr-pending' (las anyadidas en la CA)
	    $originalRequestType = getRequestTypeFromTraces ($copa);        
            $traceStatus = "$originalRequestType-pending";
            if (!$initializedXmlFileInfo) {
               $xmlFileInfo['xmlType'] = "crt";
   	       $xmlFileInfo['requestsContainer'] = "crt2ra";
	       $initializedXmlFileInfo = true;
	    }
	 }	    
	 else if ( strstr($status,"revoked-") ) {
	    $requestType = "rvk";
            // El tratamiento para cuando la CA revoca una solicitud es un
            // poco especial ya que no sabemos que tipo de solicitud es. Lo
            // vremos mas adelante	    
            if ( $status == "revoked-ca" )
               $traceStatus = $status;
	    
	    // Para los estados 'revoked-ra' y 'revoked-usr', anyadiremos las 
	    // trazas desde la que tenga el estado 'crr-pending'
            else 
	       $traceStatus = "crr-pending";

	    if (!$initializedXmlFileInfo) {
  	       $xmlFileInfo['xmlType'] = "crt";
	       $xmlFileInfo['requestsContainer'] = "crt2ra";
	       $initializedXmlFileInfo = true;
	    }
	 }	 
	 else if ( strstr($status,"-refused") ) {
	    $requestType = "rfd";
	    // Dependiendo si se ha rechazado una 'csr', una 'rnr' o una 'crr',
	    // anyadiremos las trazas desde 'csr/rnr/crr-pending'
            list($originalRequestType, $k) = split ("-refused", $status);
            $traceStatus = "$originalRequestType-pending";

	    if (!$initializedXmlFileInfo) {
  	       $xmlFileInfo['xmlType'] = "crt";
	       $xmlFileInfo['requestsContainer'] = "crt2ra";
	       $initializedXmlFileInfo = true;
	    }
	 }	    
	 else if ( $status == "ca2ra" ) 
	     $errorCode = "a1b2c11";
	 else 
            $errorCode = "a1b2c12";
	 
         if ( $errorCode == "a0") {
   	    // Guardamos en variables la informacion obtenida del ldap
            $dn = $info[0]['dn']; 
            $pkid = $info[0]['pkirisid'][0];

            // Primero escribimos los tags XML comunes a todos los tipos de 
	    // solicitudes
            $xmlString = $xmlString . "<$requestType>\n";	 
      	    // En $xmlStringSig guardamos la parte del XML de la 
	    // solicitud/certificado a la que le aplicaremos la suma de control
            $xmlStringSig = "<header>\n";   
            $xmlStringSig = $xmlStringSig . "<id>$pkid</id>\n";
            $xmlStringSig = $xmlStringSig . "<copa_id>$copa</copa_id>\n";
            $xmlStringSig = $xmlStringSig . "<dn>$dn</dn>\n";
            $xmlStringSig = $xmlStringSig . "<traces>\n";
           
	    // Obtenemos solo las trazas anyadidas desde el estado $traceStatus

	    // El caso de 'revoked-ca' tiene un tratamiento especial, ya que no
	    // podemos saber el tipo de la solicitud (puede ser una csr, una
	    // rnr o una crr). Por lo tanto, tendremos que probar para las 3. 
	    // Nos quedaremos con las trazas del estado que no devuelva 'false'
            if ( $traceStatus == "revoked-ca" ) {
	       $arrayTraces = getTracesFromStatus ($copa, "csr-pending");
	       if ( $arrayTraces == false ) {
	          $arrayTraces = getTracesFromStatus ($copa, "rnr-pending");
		  if ( $arrayTraces == false )
                     $arrayTraces = getTracesFromStatus ($copa, "crr-pending");
	       }
	    }
	    // Para el resto de casos, obtenemos las trazas anyadidas desde el
	    // estado $traceStatus
	    else
	       $arrayTraces = getTracesFromStatus ($copa, $traceStatus);
	    if ( !$arrayTraces ) 
	       $errorCode = "a1b2c13";
	    	    
	    $tracesNum = count ($arrayTraces);
            for ($k = 0; $k < $tracesNum; $k++) {
               $trace = $arrayTraces[$k];
	       $xmlStringSig = $xmlStringSig . "<trace>$trace</trace>\n";
	    }	 
            $xmlStringSig = $xmlStringSig . "</traces>\n";
  
            // Obtenemos los valores de las etiquetas del ldap
            $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
            $justthese = array ("pkirisdate","usercertificate","pkiriscertificateexpirationdate");
	    $info = ldap_get_info($ldapVar['base'],$filter,$justthese);
  	    if ( !$info ) 
	       $errorCode = "a1b2c1";
	    else {   
               $date = $info[0]['pkirisdate'][0];
               $expirationdate = $info[0]['pkiriscertificateexpirationdate'][0];
     
	       // Si el XML va a contener un certificado, tenemos que
	       // obtenerlo
	       if ($requestType == "crt") {
	          // Tambien tenemos que obtener el certificado del usuario
	          $userCert = ldap_get_cert($ldapVar['base'],$filter);
                  $derFile = $dirVar['crt'] . $copa.".x509ee";
	          // Verificamos si existe el fichero y si no lo creamos y volcamos la info del certificado en el
	          if (!file_exists($derFile)) {
	             $der = fopen($derFile, "w");
	    	     fputs($der, $userCert[0]);
		     fclose($der);
	          }
                  // Inicializamos las variables
                  $txtCert = array();
                  $data = "";
                    
                  // Pasamos el certificado a formato texto
	          $r = exec($bin['openssl'] . " x509 -text -inform DER < " .$derFile, $txtCert);
                  for($i = 0; $i < count($txtCert); $i++) 
	             $data = $data . $txtCert[$i] . "\n";                     
               }   		     
               // Escribimos las etiquetas con sus valores en la cadena      
               $xmlStringSig = $xmlStringSig . "<status>$status</status>\n";
               $xmlStringSig = $xmlStringSig . "<date>$date</date>\n";
		// Las rechazadas no llevan la fecha de expiracion
	       if ( $requestType != "rfd" )
	          $xmlStringSig = $xmlStringSig . "<expiration_date>$expirationdate</expiration_date>\n";
	    }
            $xmlStringSig = $xmlStringSig . "</header>\n";
            // Ni las revocaciones efectuadas ni las solicitudes rechazadas
	    // contendran el certificado ni la CSR (el tag data)
   	    if ( $requestType != "rvk" && $requestType != "rfd")	    
               $xmlStringSig = $xmlStringSig . "<data>\n$data</data>\n";

            // Tenemos que firmar cada certificado con la clave de secreto
	    // compartido de su RA correspondiente.  
            // Obtenemos el numero de ra ('ai')
            list ($raCopa, $k) = split ("b", $copa);
            $raPrivKey = getRaPrivKey($raCopa);
            if ( !$raPrivKey ) 
                  $errorCode = "a1b2c10";
            
            $xmlString = $xmlString . $xmlStringSig . "<sig>".sha1($xmlStringSig.$raPrivKey.$copa)."</sig>\n" . "</$requestType>\n";	 
         }
      }
   }
   
   // Una vez que tenemos el codigo XML de todas las solicitudes, creamos el
   // fichero y volcamos la informacion en el
   if ( $errorCode == "a0" ) {
      $retValue = createXMLFile( $xmlString, $xmlFileInfo ); 
      if ( !$retValue ) 
         $errorCode = "a1b2c14";
      // Si se ha generado el fichero correctamente, cambiamos el estado de
      // las solicitudes
      else { 
         $r = setExportedStatus ( $copasArray , $exportStatus ); 
	 if ( !$r ) 
  	    $errorCode = "a1b2c15";
      }
   }  
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function createXmlFile: recibe una cadena con el codigo XML correspondiente
# a todos los certificados (CRTs) o revocaciones (RVKs), le anyade una cabecera 
# y un pie con informacion sobre la version y el tipo del XML a la cadena de 
# entrada, y por ultimo crea un fichero con ellas. Devuelve la cadena generada 
# o false si ha habido algun error. El fichero se usara para enviar informacion 
# de la CA a la RA.
#
function createXMLFile ( $xmlStringSigned, $xmlFileInfo ) {
   global $raPrivKey;
   global $pkiris;
   global $dirVar;
   
   $errorCode = "a0";
   $retValue = false;
   
   $xmlType = $xmlFileInfo['xmlType'];
   $requestsContainer = $xmlFileInfo['requestsContainer'];
    
   $xmlString = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n\n";
   $xmlString = $xmlString . "<pki type=\"$xmlType\" version=\"1.0\">\n";
   
   $xmlStringTotalSig = "<$requestsContainer>\n" . $xmlStringSigned . "</$requestsContainer>\n";
   // Firmamos $xmlStringTotalSig usando la clave de secreto compartido
   // de la CA
   $privKey = $pkiris['secret'];
   $xmlString = $xmlString . $xmlStringTotalSig . "<total_sig>".sha1($xmlStringTotalSig . $privKey)."</total_sig>\n";
     
   // Por ultimo, le anyadimos el tag de cierre de 'pki'
   $xmlString = $xmlString . "</pki>\n";

   // El fichero tendra el siguiente nombre
   $xmlFile = $dirVar['crt2ra'] . "ca2ra_d".date('Ymd')."t".date('His').".xml";
   
   // Abrimos el fichero para escribir 
   $fd = fopen ($xmlFile, "w");
   
   if ( !$fd )
      $errorCode = "a1b2c17";
   else {
      // Si no hay errores, escribimos la cadena XML en el fichero
      $r = fwrite ($fd, $xmlString);
      if ( !$r )
         $errorCode = "a1b2c18";

      $r = fclose ($fd);
      if ( !$r )
         $errorCode = "a1b2c19";
   }

   // Si no ha habido errores, devolvemos la cadena con el XML
   if ( $errorCode == "a0" )
      $retValue = $xmlString;
     
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

#
# function revoke: recibe el codigo copa de una solicitud de revocacion y 
# revoca el certificado correspondiente. Tambien recibe el estado al que 
# pasara el certificado (revoked-usr, revoked-ra o revoked-ca), es decir, 
# si lo ha revocado el usuario, el administrador de la RA o el de la CA. 
# En el ultimo caso, la revocacion debe llevarse a cabo lo antes posible, 
# sin tener en cuenta el estado del certificado. El ultimo paramentro de
# entrada, la 'passPhrase', es la contrasenya de la CA, y es necesaria para 
# efectuar cualquier operacion de la CA. Devuelve 'true' si no ha habido 
# ningun error; 'false' en caso contrario. 
#
function revoke ( $copa, $status, $passPhrase ) {
   global $dirVar;
   global $ldapVar; 
   global $bin;
   global $fileVar; 

   $errorCode = "a0";
   $retValue = false;
   $dn = $ldapVar['rdnAttr']."=$copa,".$ldapVar['base'];   
   $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
   $justthese = array ("pkirisrevocationreason");
   $info = ldap_get_info($dn,$filter,$justthese);
   if ( !$info )
      $errorCode = "a1b2c1";
   else {
      $revReason = $info[0]["pkirisrevocationreason"][0];
      // Comprobamos si el estado anterior al que queremos cambiar
      // es valido, es decir, si cumple el diagrama de estados. Con
      // esto evitamos que se escriba dos veces el mismo estado al
      // refrescar la pagina en el navegador, entre otras cosas
      $lastStatus = getStatus($copa);
      if ( !$lastStatus )
         $errorCode = "a1b2c20";
      else {
         if ( ($lastStatus == "crr-deferred" || $lastStatus == "crr-pending" || $status = "revoked-ca") && ($lastStatus != $status) ) {
            // Nos traemos el certificado el ldap
            $justthese = array("usercertificate");
            $userCert = ldap_get_cert($dn,$filter,$justthese);
            if ( !$userCert ) 
               $errorCode = "a1b2c2";
            else {
               // Y si no existe el fichero '.der' correspondiente al
               // mismo lo creamos
               $derFile = $dirVar['crt']."$copa.der";
               if ( !file_exists($derFile) ) {
                  $der = fopen ($derFile, "w");
                  if ( !$der )
                     $errorCode = "a1b2c17";
                  else {
                     $fp = fputs($der, $userCert[0]);
                     if ( !$fp )
                        $errorCode = "a1b2c18";
                     else {
                        $fc = fclose ($der);
                        if ( !$fc )
                           $errorCode = "a1b2c19";
                     }
                  }
               }
               // Mediante el siguiente comando de openssl, pasamos el
               // certificado del formato '.der' a '.pem'
               $opensslCommand = $bin['openssl'] ." x509 -in $derFile -inform DER -out ".$dirVar['crt']."$copa.pem -outform PEM";
               // Con este comando revocamos el certificado '.pem'
               $opensslCommand2 = "pkirisID=NULL pkirisEMAIL=NULL ".$bin['openssl']." ca -revoke ".$dirVar['crt']."$copa.pem -key $passPhrase -config ".$fileVar['opensslConf']." -crl_reason $revReason 2>&1";
               $execReturn = system($opensslCommand,$retval);
               $execReturn2 = system($opensslCommand2,$retval);
               if ( $execReturn2 != "Data Base Updated" )
                  $errorCode = "a1b2c21";
            }
         }
         else 
            $errorCode = "a1b2c11";
      }
   }
  
   // Si no ha habido errores, devolvemos 'true'
   if ( $errorCode == "a0" )
      $retValue = true;

   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}

# 
# function sign: recibe el codigo copa de una solicitud de certificado y
# si todo es correcto, emite el certificado correspodiente. Tambien recibe el 
# estado al que pasara el certificado. El ultimo paramentro de entrada, la 
# 'passPhrase', es la contrasenya de la CA, y es necesaria para efectuar 
# cualquier operacion de la CA. Genera el certificado en tres formatos: en der, 
# en pem y en texto. Devuelve 'true' si no ha habido ningun error; 'false' en 
# caso contrario.
#
function sign ( $copa, $status, $passPhrase ) {
   global $dirVar;
   global $ldapVar;
   global $bin;
   global $fileVar;

   $errorCode = "a0";
   $retValue = false;
   $subjString = '';
   // Nos traemos de ldap la informacion necesaria para
   // emitir el certificado
   $dn = $ldapVar['rdnAttr']."=$copa,".$ldapVar['base'];
   $filter = ("pkirisCopaID=$copa");
   $justthese = array ("pkiriscsr", "pkiriscerttype", "pkirissubjectdn", "pkirisshowmail", "mail");
   $info = ldap_get_info($dn,$filter,$justthese);
   if (!$info) 
      $errorCode = "a1b2c1";
   else {
      $requestId = $info[0]['pkirisid'][0];
      $pkirisCSR = $info[0]['pkiriscsr'][0];
      $certType = $info[0]['pkiriscerttype'][0];
      $subjectDN = $info[0]['pkirissubjectdn'][0];
      $showMail = $info[0]['pkirisshowmail'][0];
      $mail = $info[0]['mail'][0];

      if ( strncmp("SPKAC", $pkirisCSR, 5) == 0 ) {
         $csrType = "SPKAC";

         // Para que openssl funcione correctamente, tenemos que
         // pasarle el SubjectDN de la forma: /DC=a/DC=b/O=c/CN=d
         $arraySubjectDN = split (",",$subjectDN);
         for ($i=0; $i<count($arraySubjectDN); $i++){
            list($leftValue, $rightValue) = split ("=", $arraySubjectDN[$i]);
            $leftValue = strToUpper ($leftValue);
            // Si el subjectDN es de un certificado de servicio, hay
            // que añadirle el caracter de escape"\" antes de l
            // barra "/" para evitar conflictos con openssl
            list($rightValue, $subValue) = split ("/", $rightValue);
            if ($subValue != "")
               $rightValue = $rightValue . '\\/' . $subValue;
               $subjString = "$subjString/$leftValue=$rightValue";
         }
      }
      else
         $csrType = "IE";

      // Tenemos que crear un fichero con la clave privada
      $csrFileName = $dirVar['crt']."$copa.csr";
      $fd = fopen ($csrFileName, w);
      if ( !$fd ) 
         $errorCode = "a1b2c17";
      else {
         $r = fwrite ($fd, $pkirisCSR);
         if ( !$r )
            $errorCode = "a1b2c18";
         else {
            // Comprobamos que estamos en un estado valido
            $lastStatus = getStatus($copa);
            if ( !$lastStatus )
               $errorCode = "a1b2c20";
            else {
               if ( ($lastStatus == "csr-deferred" || $lastStatus == "rnr-deferred" || $lastStatus == "csr-pending" || $lastStatus == "rnr-pending") && ($lastStatus != $status) ) 
               {
                  // Si el certificado es de tipo usuario y este lo permite,
                  // firmaremos con su email
                  if ( ($showMail == "TRUE") AND ($certType == "usr") )
                     $extensions = "usr_cert_sujectAltName_mail";
                  else {
                     $extensions = "$certType"."_cert";
                     $mail = "NULL";
                  }
                  // Para firmar ejecutamos un comando de openssl con una
                  // serie de argumentos. El comando sera diferente
                  // dependiendo del tipo de CSR (spkac o msie)
                  if ( $csrType == "SPKAC" )
                     $opensslCommand = "pkirisID=$copa pkirisEMAIL=$mail ".$bin['openssl']." ca -spkac $csrFileName -key $passPhrase -config ".$fileVar['opensslConf']." -subj \"$subjString\" -extensions $extensions -out ".$dirVar['crt']."$copa.der 2>&1";
                  else // IE
                     $opensslCommand = "pkirisID=$copa pkirisEMAIL=$mail ".$bin['openssl']." ca -in $csrFileName -key $passPhrase -config ".$fileVar['opensslConf']." -extensions $extensions -out ".$dirVar['crt']."$copa.txt -batch 2>&1";

                  // Ejecutamos el comando
                  $execReturn = system($opensslCommand,$retval);
                  // Si falla la ejecucion del mismo, apuntamos el error
                  // y no seguimos el proceso de firma
                  if ( $execReturn != "Data Base Updated" ) 
                     $errorCode = "a1b2c22";
                  else {
                     // Para las solicitudes de SPKAC se genera el
                     // certificado en formato '.der' y lo necesitamos
                     // en '.pem' para obtener la fecha de expiracion
                     if ( $csrType == "SPKAC" ) {
                        $opensslCommand2 = $bin['openssl']." x509 -in ".$dirVar['crt']."$copa.der -inform DER -out ".$dirVar['crt']."$copa.pem -outform PEM";
                        $execReturn2 = system($opensslCommand2,$retval);
                     }
                     // En las de tipo IE, se genera el certificado en
                     // formato texto. Lo necesitamos en '.pem' y en
                     // '.der'
                     else {
                        $opensslCommand2 = $bin['openssl']." x509 < ".$dirVar['crt']."$copa.txt > ".$dirVar['crt']."$copa.pem";
                        $opensslCommand3 = $bin['openssl']." x509 -in ".$dirVar['crt']."$copa.pem -inform PEM -out ".$dirVar['crt']."$copa.der -outform DER";
                        $execReturn2 = system($opensslCommand2,$retval);
                        $execReturn3 = system($opensslCommand3,$retval);
                     }
                  /* if ( $execReturn2 != "Data Base Updated" ) {
                     $errorDescription = $errorDescription . "\nOpenssl: $execReturn2";
                     $errorCode = 69;
                  }*/
                  }
               }
               else 
                  $errorCode = "a1b2c11";
            }
         }
         fclose ($fd);
      }
   }

   if ( $errorCode == "a0" )
      $retValue = true;

   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}


#
# function getRaPrivKey(): devuelve la clave privada de la RA indicada por
# '$copa'. Buscara en el fichero de claves privadas aquella que tenga la fecha
# mas cercana a la actual pero menor que ella.
#
function getRaPrivKey($copa) {
   global $dirVar;
   global $ldapVar;
   
   $errorCode = "a0";
   $retValue = false;
   // Si existe el fichero con todas las claves privadas de todas las RAs,
   // obtenemos la clave de la RA indicada por $copa
   if ( file_exists($dirVar['conf'] . 'private.conf') ) {
      // Incluimos el fichero con todas las claves privadas de todas las RAs
      include $dirVar['conf'] . 'private.conf';
      // Ordenamos el array de mayor a menor fecha y nos quedamos con la 
      // primera que sea menor que la fecha actual
      if ( count ( $raPrivKeyArray[$copa] ) > 0 ) {
         krsort( $raPrivKeyArray[$copa] );
         $currentDate = date ("YmdHis");
         $found = false;
         while ( (list($date, $key) = each ($raPrivKeyArray[$copa])) && !$found) {
            if ( $date < $currentDate ) {
	       $retValue = $key;
	       $found = true;
	    }
         }
      }
   }   
   else 
      $errorCode = "a1b2c16";
   
   $pkiLog['status'] = "none";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "none";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);

   return $retValue;
}																	 

############################### VARIABLES #####################################

// Ca Side Menu
$menu[4]["data_import.php"] = "Importar Solicitudes";
$menu[4]["manage.php"] = "Gestionar Solicitudes";
$menu[4]["gen_crl.php"] = "Generar CRLs";
$menu[4]["revoke.php"] = "Revocar Certificados";
$menu[4]["data_export.php"] = "Exportar Certificados";
$menu[4]["raPrivKey_import.php"] = "Importar Claves";

// All posible ca manage actions array
   # CRRs
$caManageActions["crr"]["Revocar"] = "revoked-";
$caManageActions["crr"]["Aplazar"] = "crr-deferred";
$caManageActions["crr"]["Rechazar"] = "crr-refused";
   # CSRs
$caManageActions["csr"]["Firmar"] = "issued";
$caManageActions["csr"]["Aplazar"] = "csr-deferred";
$caManageActions["csr"]["Rechazar"] = "csr-refused";
   # RNRs
$caManageActions["rnr"]["Firmar"] = "issued";
$caManageActions["rnr"]["Aplazar"] = "rnr-deferred";
$caManageActions["rnr"]["Rechazar"] = "rnr-refused";
	 
###############################################################################

?>
